/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: ProductionSystem.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _TOPS_PRODUCTION_SYSTEM_HPP_
#define _TOPS_PRODUCTION_SYSTEM_HPP_

#include "tops/PSListener.hpp"
#include "tops/RuleBase.hpp"
#include "tops/WorkingMemory.hpp"

#include "tops/utilities/CloseContainer.hpp"

#include <boost/shared_ptr.hpp>

namespace tops {

	class AttributeOfFact;
	class Constant;
	typedef boost::shared_ptr<Constant> ConstantPtr;
	class Instance;
	class PSListener;
	typedef boost::shared_ptr<PSListener> PSListenerPtr;

	class ProductionSystem;
	typedef boost::shared_ptr<ProductionSystem> ProductionSystemPtr;

	/**
	 * プロダクションシステムです。
	 *
	 * @author トゥイー
	 */
	class ProductionSystem {
	private:
		typedef Utility::CloseList<PSListener*> ListenerContainer;
		typedef ListenerContainer::iterator listener_iterator;
		typedef ListenerContainer::const_iterator listener_const_iterator;

		ListenerContainer m_listeners;

	protected:
		/**
		 * ルールベースです。
		 */
		RuleBase m_ruleBase;

		/**
		 * ワーキングメモリです。
		 */
		WorkingMemory m_workingMemory;

	public:
		/**
		 * ルールベースを取得します。
		 */
		const RuleBase& getRuleBase() const {
			return m_ruleBase;
		}

		/**
		 * ワーキングメモリを取得します。
		 */
		const WorkingMemory& getWorkingMemory() const {
			return m_workingMemory;
		}

	public:
		/**
		 * プロダクションシステムを破棄します。
		 */
		virtual ~ProductionSystem() {
		}

	public:
		/**
		 * ルールを追加します。
		 *
		 * @param rule 追加するルールを指定します。
		 *
		 * @return
		 * 追加が成功した場合は追加されたプロダクションルールを、それ以外の場合はNULLを返します。
		 * ここで返されたプロダクションルールは、
		 * プロダクションシステムによって管理されるため、deleteする必要はありません。
		 */
		ProductionRule* add(const RulePtr& rule);

		/**
		 * 事実を追加します。
		 *
		 * @param fact 追加する事実を指定します。
		 * @param source インスタンス元を指定します。
		 *
		 * @return
		 * 追加が成功した場合は追加されたワーキングメモリ要素を、それ以外の場合はNULLを返します。
		 * ここで返されたワーキングメモリ要素は、
		 * プロダクションシステムによって管理されるため、deleteする必要はありません。
		 */
		WMElement* add(const FactPtr& fact, const Instance* source = 0);

		/**
		 * 属性を追加します。
		 *
		 * @param element 属性の追加対象となるワーキングメモリ要素を指定します。
		 * @param name 追加する属性の属性名を指定します。
		 * @param constant 追加する属性の属性値となる定数を指定します。
		 * @param source インスタンス元を指定します。
		 *
		 * @return 追加が成功した場合は追加された属性を、それ以外の場合はNULLを返します。
		 */
		AttributeOfFact* add(
				WMElement& element,
				const std::string& name,
				const ConstantPtr& constant,
				const Instance* source = 0);

	public:
		/**
		 * 事実に対応するワーキングメモリ要素を取得します。
		 *
		 * @return 存在する場合は対応するワーキングメモリ要素を、存在しない場合はNULLを返します。
		 */
		WMElement* find(const FactPtr& fact);

	public:
		/**
		 * イベントリスナを追加します。
		 */
		void addListener(const PSListenerPtr& listener) {
			m_listeners.push_front(listener.get());
		}

		/**
		 * イベントリスナを追加します。
		 */
		void addListener(PSListener& listener) {
			m_listeners.push_front(&listener);
		}

	private:
		/**
		 * プロダクションルールが追加されたことをイベントリスナに通知します。
		 */
		void notifyAdded(ProductionRule& rule);

		/**
		 * ワーキングメモリ要素が追加されたことをイベントリスナに通知します。
		 */
		void notifyAdded(WMElement& element);

		/**
		 * 属性が追加されたことをイベントリスナに通知します。
		 */
		void notifyAdded(WMElement& element, const std::string& name, const ConstantPtr& constant);

	public:
		virtual void update() {
		}
	};

}  // namespace tops

#endif
